package helpers;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;

import com.tableausoftware.TableauException;
import com.tableausoftware.common.Collation;
import com.tableausoftware.common.Type;
import com.tableausoftware.extract.Extract;
import com.tableausoftware.extract.ExtractAPI;
import com.tableausoftware.extract.Row;
import com.tableausoftware.extract.Table;
import com.tableausoftware.extract.TableDefinition;

public class ExtractCreator {
	
	private List<String[]> csvTable;
	
	public TableDefinition createTableDefinitionFromCSV(String csvPath) throws TableauException {

		TableDefinition tableDef = new TableDefinition();

		csvTable = tryReadFromCSV(csvPath);
		
		for (String row : csvTable.get(0)) {

			tableDef.addColumn(row, Type.CHAR_STRING);
		}

		return tableDef;
	}

	private void insertDataFromCSV(TableDefinition tableDef, Table table) throws TableauException {
				
		for (int i = 1; i < csvTable.size(); i++) {
				
			int column = 0;
			Row row = new Row(tableDef);
			
			for (String val : csvTable.get(i)) {
				
		        row.setCharString(column, val);
		        column++;
			}
		    table.insert(row);
		}
	}

	private List<String[]> tryReadFromCSV(String csvPath) {
		CSVHelper csvHelper = new CSVHelper();

		try {
			List<String[]> csvList = csvHelper.readFromCsvToTable(csvPath);
			return csvList;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;

	}
	
	public void CreateExtract(String extractName, String tableName, String csv)
	{
        try {
        	
            ExtractAPI.initialize();

            try (Extract extract = new Extract(extractName + ".tde")) {

                Table table;
                if (!extract.hasTable("Extract")) {
                	
                    TableDefinition tableDef = createTableDefinitionFromCSV(csv);        
                    table = extract.addTable("Extract", tableDef);
                }
                else {

                    table = extract.openTable("Extract");
                }

                TableDefinition tableDef = table.getTableDefinition();

                insertDataFromCSV(tableDef,table);
            }

            ExtractAPI.cleanup();
        }
        catch (Throwable t) {
            t.printStackTrace(System.err);
        }
	}
}
